<?php

namespace SGalinski\SgNews\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgNews\Service\Backend\Utility;
use TYPO3\CMS\Backend\Template\Components\DocHeaderComponent;
use TYPO3\CMS\Backend\Utility\BackendUtility;
use TYPO3\CMS\Core\Authentication\BackendUserAuthentication;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;

/**
 * News Controller
 */
class BackendController extends ActionController {

	/**
	 * DocHeaderComponent
	 *
	 * @var DocHeaderComponent
	 */
	protected $docHeaderComponent;

	/**
	 * @var \SGalinski\SgNews\Domain\Repository\NewsRepository
	 * @inject
	 */
	private $newsRepository;

	/**
	 * @var \SGalinski\SgNews\Domain\Repository\CategoryRepository
	 * @inject
	 */
	private $categoryRepository;

	/**
	 * @var \SGalinski\SgNews\Domain\Repository\TagRepository
	 * @inject
	 */
	private $tagRepository;

	public function indexAction() {
		// create doc header component
		$pageUid = (int) GeneralUtility::_GP('id');
		/** @var BackendUserAuthentication $backendUser */
		$backendUser = $GLOBALS['BE_USER'];
		$pageInfo = BackendUtility::readPageAccess($pageUid, $backendUser->getPagePermsClause(1));
		$this->docHeaderComponent = GeneralUtility::makeInstance(DocHeaderComponent::class);
		$this->docHeaderComponent->setMetaInformation($pageInfo);
		Utility::makeButtons($this->docHeaderComponent, $this->request);

		// retrieve next site root id
		$siteRootId = Utility::getSiteRoot((int) GeneralUtility::_GP('id'));
		$categories = Utility::getCategoriesForSiteRoot($siteRootId);

		$this->view->assign('docHeader', $this->docHeaderComponent->docHeaderContent());
		$this->view->assign('pageUid', $pageUid);
		$this->view->assign('categories', $categories);
	}
}
